-- handle player hud visibility

local Update = function(self,event,unit)

  --if (unit ~= "player") then return; end
  
  self.HUDFaderCurrentAlpha = 0;
  self.HUDFaderCurrentState = "nostate"

  if (UnitAffectingCombat("player")) then
    self.HUDFaderCurrentAlpha = 1
    self.HUDFaderCurrentState = "combat"
  elseif( UnitCastingInfo("player") ) then
    self.HUDFaderCurrentAlpha = 1
    self.HUDFaderCurrentState = "cast"
  elseif ( ((UnitHealthMax("player") - UnitHealth("player")) > 0) or ((UnitPowerMax("player") - UnitPower("player")) > 0) ) then
    self.HUDFaderCurrentAlpha = 0.7
    self.HUDFaderCurrentState = "regen"
  elseif (event == "PLAYER_REGEN_DISABLED") then
    self.HUDFaderCurrentAlpha = 0
    self.HUDFaderCurrentState = "hide"
  else
    self.HUDFaderCurrentAlpha = 0
    self.HUDFaderCurrentState = "hide"
  end
    
  self:SetAlpha(self.HUDFaderCurrentAlpha)
  
end

local Enable = function(self, unit)
  if unit == "player" or unit=="pet" then
    Update(self,"NOEVENT",unit)
    self:RegisterEvent("PLAYER_REGEN_DISABLED", Update)
    self:RegisterEvent("PLAYER_REGEN_ENABLED", Update)
    
    self:RegisterEvent("UNIT_HEALTH", Update)
    
    self:RegisterEvent("UNIT_MANA", Update)
    self:RegisterEvent("UNIT_FOCUS", Update)
    self:RegisterEvent("UNIT_RAGE", Update)
    self:RegisterEvent("UNIT_ENERGY", Update)
    self:RegisterEvent("UNIT_DISPLAYPOWER", Update)
    self:RegisterEvent("UNIT_RUNIC_POWER", Update)
      
    self:RegisterEvent("UNIT_SPELLCAST_CHANNEL_START", Update)
    self:RegisterEvent("UNIT_SPELLCAST_CHANNEL_UPDATE", Update)
    self:RegisterEvent("UNIT_SPELLCAST_DELAYED", Update)
    self:RegisterEvent("UNIT_SPELLCAST_FAILED", Update)
    self:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED", Update)
    self:RegisterEvent("UNIT_SPELLCAST_START", Update)
    self:RegisterEvent("UNIT_SPELLCAST_STOP", Update)
    self:RegisterEvent("UNIT_SPELLCAST_CHANNEL_STOP", Update)
    
    self:RegisterEvent("PLAYER_TARGET_CHANGED", Update)    
    return true
  end
end

local Disable = function(self,unit)

  Update(self,"NOEVENT",unit)
  self:UnregisterEvent("PLAYER_REGEN_DISABLED", Update)
  self:UnregisterEvent("PLAYER_REGEN_ENABLED", Update)
  
  self:UnregisterEvent("UNIT_HEALTH", Update)
  
  self:UnregisterEvent("UNIT_MANA", Update)
  self:UnregisterEvent("UNIT_FOCUS", Update)
  self:UnregisterEvent("UNIT_RAGE", Update)
  self:UnregisterEvent("UNIT_ENERGY", Update)
  self:UnregisterEvent("UNIT_DISPLAYPOWER", Update)
  self:UnregisterEvent("UNIT_RUNIC_POWER", Update)
  
  self:UnregisterEvent("UNIT_SPELLCAST_CHANNEL_START", Update)
  self:UnregisterEvent("UNIT_SPELLCAST_CHANNEL_UPDATE", Update)
  self:UnregisterEvent("UNIT_SPELLCAST_DELAYED", Update)
  self:UnregisterEvent("UNIT_SPELLCAST_FAILED", Update)
  self:UnregisterEvent("UNIT_SPELLCAST_INTERRUPTED", Update)
  self:UnregisterEvent("UNIT_SPELLCAST_START", Update)
  self:UnregisterEvent("UNIT_SPELLCAST_STOP", Update)
  self:UnregisterEvent("UNIT_SPELLCAST_CHANNEL_STOP", Update)
  
  self:UnregisterEvent("PLAYER_TARGET_CHANGED", Update)  
 
end

oUF:AddElement('HUDFader', Update, Enable, Disable)


