local function Hex(r, g, b,raw)
	if type(r) == "table" then if r.r then r, g, b = r.r, r.g, r.b else r, g, b = unpack(r) end end
	if not raw then return string.format("|cff%02x%02x%02x", r*255, g*255, b*255) end
	return string.format("%02x%02x%02x", r*255, g*255, b*255)
end

oUF.Tags["[hudhp]"] = function(u)
	local m = UnitHealthMax(u)
	return m == 0 and 0 or "[|cff00cc66"..math.floor(UnitHealth(u)/m*100+0.5).."|r%]"
end
oUF.TagEvents["[raidicon]"] = oUF.TagEvents["[curpp]"]

oUF.Tags["[name]"] = function(u, r) 
	local n = UnitName(r or u) or ''	
	if n == UnitName("player") then
		return '|cff00ff00 !!! ICH !!! |r'
	end	
	return n
end

oUF.Tags["[reactioncolor]"] = function(u)
  if(UnitIsTapped(u) and not UnitIsTappedByPlayer(u)) then
    return Hex(unpack(oUF.colors.tapped))
  elseif (UnitIsDead(u) or UnitIsGhost(u) or not UnitIsConnected(u)) then
    return Hex(unpack(oUF.colors.disconnected))
  elseif (not UnitIsPlayer(u)) then
    red, green, blue, alpha = UnitSelectionColor(u)
    return Hex(unpack({red,green,blue} or oUF.colors.health))
  else
    local _, x = UnitClass(u)
    return x and Hex(oUF.colors.class[x])  
  end
end

oUF.Tags["[raidicon]"] = function(u)
  local i = GetRaidTargetIndex(u);
  return i and ICON_LIST[i]..'28|t ' or ''
end
oUF.TagEvents["[raidicon]"] = 'UNIT_TARGET RAID_TARGET_UPDATE'